var _tmpl = "<h1 id=\"_title\"></h1>"+
           "<div class=\"left\"><img id=\"_image\" src=\"\" alt=\"nophoto\" width=\"140\" height=\"200\"/></div>"+
           "<div class=\"right\">"+
           "<span class=\"head\">director</span><br/><span id=\"_directors\"></span><br/>"+
           "<span class=\"head\">year</span><br/><span id=\"_year\"></span><br/>"+
           "<span class=\"head\">runtime</span><br/><span id=\"_runtime\"></span><br/>"+
           "<span class=\"head\">genre</span><br/><span id=\"_genre\"></span><br/>"+
           "<span class=\"head\">rating</span><br/><span id=\"_rating\"></span>"+
           "</div>"+
           "<div class=\"desc\" id=\"_desc\"></div>";

var _sel = -1;

function display (filter)
{
	//# fill the table with library
	var obj = $("#list > ul"), 
		i, 
		update, 
		time=0,
		add = false,
		count=0;
		
	if (filter.length > 0) {
		$("#list li").removeClass("selected");
	}
	
	obj.html ("");
	
	for (i=0;i<lst.length;i++) {
		add=(filter.length>0) ? (lst[i].title.search(filter)!=-1) : true;
		if (add) { 
			obj.append ("<li rel=\""+i+"\">"+lst[i].title+"<small>"+lst[i].len+" min</small></li>");
			time+= parseInt (lst[i].len,10);
			count++;
		}
	}
	update = count + " movies | ";
	if (time <60) {
		update += time + " min";
	}
	else {
		var d,h,m;
		if (time < (1440)) {    //one day?
			h = time / 60;
			m = time % 60;
			update += Math.floor(h) + " h, " + Math.floor(m) + " min";
		}
		else {
			m = time % 1440;
			d = time / 1440;
			h = m/60;
			m = m%60;
			update += Math.floor(d) + " d, " + Math.floor(h) + " h, " + Math.floor(m) + " min";
		}
	}
	$("#info").text (update);
	
	$("li",obj).click ( function () {
		_sel = parseInt ($(this).attr("rel"),10);
		item (_sel); 
		$("#list li").removeClass("selected");
		$(this).addClass ("selected");
	});
}

function stream ()
{
   var mobile = (/iphone|ipad|ipod|android|blackberry|mini|windows\sce|palm/i.test(navigator.userAgent.toLowerCase()));  
   if (mobile) {  
      return;
   }  
   setInterval (function () {
      //# asynchron request for changes
      $.ajax ({
              url: "application.stream",
              async:true,
              success: function(data){
                  var buf="",lines = data.split ("\n");
                  lines.shift ();

                  lst.splice (0,lst.length);
                  eval (lines.join("\n"));
                  display ("");
              }
      });
   },30000);
} 
	   
$(document).ready(function() {
	display("");
	item(-1);
	
	$("#view, #list, #info, #searchbar").hide ();
	
	$("#view").fadeIn (1000);
	setTimeout (function () {$("#list").fadeIn (1000);$("#info").fadeIn();},1000);
	setTimeout (function () {$("#searchbar").slideDown();}, 2000);
	
	$("#searchbar input").keyup(function () {
		display ($(this).val());
	});
   
   stream();
});

function item (uid)
{
  $("#view").html (_tmpl);

  var	p;
  if (uid == -1) {
	p = {title: "cMovie", image: "nophoto.png", directors: "Daniel Kagemann", year: "2011", len: "a lot of", rating: 5, category: "mac application", description: "a small media library with a minimalistic and intuitive user interface. "};
  }
  else {
	p = lst[uid];
  }
  $("#_title").html(p.title);
  $("#_image").attr("src",p.image);
  $("#_directors").html(p.directors);
  $("#_year").html(p.year);
  $("#_runtime").html(p.len + " min");
  $("#_rating").html(p.rating + "/5");
  $("#_desc").html(p.description);
  $("#_genre").html(p.category);
}
